/*
  Copyright 1998 NOKUBI Takatsugu

$Id: Kakasi.xs,v 1.5 1999/12/03 08:52:10 knok Exp $
*/

#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include "libkakasi.h"

static int dic_closed = 1;

MODULE = Text::Kakasi		PACKAGE = Text::Kakasi

PROTOTYPES: DISABLE

int
getopt_argv(sv,...)
    SV* sv

    PREINIT:
	int i;
	char **cargv, **argv;
	int argc;

    CODE:
	RETVAL = 0;
	if (!dic_closed)
		kakasi_close_kanwadict();
	argc = items;
	cargv = (char **) malloc(sizeof(char *) * items + 1);
	for (i = 0; i <= items; i ++) {
	    cargv[i] = SvPV(ST(i), na);
	}
	cargv[items] = NULL;
	argv = cargv;
	RETVAL = kakasi_getopt_argv(argc, argv);

    OUTPUT:
	RETVAL

SV*
do_kakasi(sv)
	SV *sv

    PREINIT:
	char *tmp, *ret, *rtmp;
	STRLEN slen, cur, rcur, tlen, rlen;

    CODE:
	tmp = SvPV(sv, slen);
	rlen = 0;
	cur = 0;
	rcur = 0;
	ret = NULL;
	do {
		rtmp = kakasi_do(tmp);
		tlen = strlen(rtmp);
		if (ret == NULL) {
			ret = malloc(tlen + 1);
			strncpy(ret, rtmp, tlen + 1);
			rcur = tlen + 1;
		} else {
			ret = realloc(ret, rcur + tlen + 1);
			strncpy((ret + rcur), rtmp, tlen + 1);
			rcur += tlen + 1;
		}
		while (*tmp != '\0') {
			tmp ++;
			cur ++;
		}
		while (*tmp == '\0' && cur < slen) {
			tmp ++;
			cur ++;
		}
		free(rtmp);
	} while (cur < slen);
	if (ret != NULL) {
		RETVAL = newSVpv(ret, rcur - 1);
		Safefree(ret);
	} else {
		RETVAL = newSVpv("", 0);
	}

    OUTPUT:
	RETVAL

int
close_kanwadict()

    CODE:
	RETVAL = kakasi_close_kanwadict();

    OUTPUT:
	RETVAL
